//	uart_typ.c - determine designation of UART
//	Mike Dawdy, Compuserve ID 76275,700

//	returns a value in {0, 1, ..., 4} indicating UART type

#include  "uart.h"

#define	UNKNOWN		0
#define	INS8250B	1
#define	NS16450		2
#define	NS16550		3
#define	NS16550A	4

unsigned uart_type(unsigned addr)
{
unsigned iir;

outp(addr+SCR, 0x12);
IO_DELAY
if (inp(addr+SCR) != 0x12) return(INS8250B);

outp(addr+FCR, 0x01);	// enable FIFOs
iir = inp(addr+IIR);
outp(addr+FCR, 0x00);	// reset FIFOs

if ((iir & 0xc0) == 0x00) return(NS16450);	
if ((iir & 0xc0) == 0x80) return(NS16550);
if ((iir & 0xc0) == 0xc0) return(NS16550A);

return(UNKNOWN);
}

